diff -ruN qmail-1.03-orig/pbscheck.c qmail-1.03-ldap-20060201-orig/pbscheck.c
--- qmail-1.03-orig/pbscheck.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/pbscheck.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,421 @@
+/*
+ * Copyright (c) 2002-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <unistd.h>
+#include "alloc.h"
+#include "auto_qmail.h"
+#include "byte.h"
+#include "control.h"
+#include "env.h"
+#include "error.h"
+#include "exit.h"
+#include "fmt.h"
+#include "ip.h"
+#include "now.h"
+#include "open.h"
+#include "str.h"
+#include "stralloc.h"
+#include "substdio.h"
+#include "timeoutread.h"
+#include "timeoutwrite.h"
+
+static void die(void);
+static int safewrite(int, void *, int);
+static void putstr(const char *);
+static void flush(void);
+static void errstr(const char *);
+static void logit(const char *);
+static void die_usage(void);
+static void die_exec(void);
+static void die_badenv(void);
+static void die_control(void);
+static void die_nomem(void);
+static void die_envs(void);
+static void die_dir(void);
+static void die_dirback(void);
+void setup(void);
+static void uint16_pack_big(char [], unsigned int);
+int sendrequest(int, char *, unsigned int, struct ip_address *);
+int env_snap(void);
+void env_rewrite(char**, char**);
+void setenv(char *, unsigned int);
+
+char ssoutbuf[128];
+substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);
+
+char sserrbuf[128];
+substdio sserr = SUBSTDIO_FDBUF(safewrite,2,sserrbuf,sizeof sserrbuf);
+
+#define MAX_PACKET_SIZE 1024
+char packet[MAX_PACKET_SIZE];
+
+stralloc addresses = {0};
+stralloc envs = {0};
+struct ip_address *servers;
+unsigned int numservers = 0;
+unsigned int numenvs = 0;
+unsigned int serverport = 2821;
+
+
+void
+setup(void)
+{
+	char* s;
+	unsigned int i, len;
+	int fdsourcedir;
+
+	fdsourcedir = open_read(".");
+	if (fdsourcedir == -1)
+		die_dir();
+
+	if (chdir(auto_qmail) == -1) die_control();
+
+	if (control_readfile(&addresses,"control/pbsservers",0) != 1)
+	       	die_control();
+
+	if (control_readint(&serverport,"control/pbsport") == -1)
+	       	die_control();
+	if (serverport > 65000)
+	       	die_control();
+	if (control_readfile(&envs,"control/pbsenv",0) == -1)
+	       	die_control();
+
+	if (fchdir(fdsourcedir) == -1)
+		die_dirback();
+	close(fdsourcedir);
+
+	for (i = 0; i < addresses.len; i++)
+		if( addresses.s[i] == '\0') numservers++;
+	if (numservers == 0) die_control();
+
+	for (i = 0; i < envs.len; i++)
+		if( envs.s[i] == '\0') numenvs++;
+	if (numenvs > 255) die_envs();
+
+	servers = (struct ip_address*)
+	    alloc(numservers * sizeof(struct ip_address));
+	if (!servers) die_nomem();
+
+	s = addresses.s;
+	for (i = 0; i < numservers; i++) {
+		len = ip_scan(s, &servers[i]);
+		if (len == 0 || len > 15) die_control();
+		while (*s++);
+	}
+}
+
+
+static void
+uint16_pack_big(char s[2], unsigned int u)
+{
+	s[1] = u & 255;
+	s[0] = (u >> 8) & 255;
+}
+
+int
+sendrequest(int fd, char *buf, unsigned int len, struct ip_address *ip)
+{
+	struct sockaddr_in s;
+
+	byte_zero(&s,sizeof(s));
+	byte_copy(&s.sin_addr,4,ip);
+	uint16_pack_big((char *)&s.sin_port, serverport);
+	s.sin_family = AF_INET;
+
+	return sendto(fd, buf, len, 0, (struct sockaddr*)&s, sizeof(s));
+}
+
+char **envsnap;
+
+int
+env_snap(void)
+{
+	unsigned int en, i;
+	
+	for (en = 0;environ[en];++en) ;
+	envsnap = (char **) alloc((en + 1) * sizeof(char *));
+	if (!envsnap) return 0;
+	for (en = 0;environ[en];++en) {
+		envsnap[en] = alloc(str_len(environ[en]) + 1);
+		if (!envsnap[en]) {
+			for (i = 0; i < en; ++i) alloc_free(envsnap[i]);
+			alloc_free(envsnap);
+			return 0;
+		}
+		str_copy(envsnap[en],environ[en]);
+	}
+	envsnap[en] = 0;
+	return 1;
+}
+
+stralloc vbuf = {0};
+
+void
+env_rewrite(char** name, char** value)
+{
+	char *e;
+	unsigned int i;
+	unsigned int llen;
+	unsigned int nlen;
+	unsigned int elen;
+
+	e = envs.s;
+	nlen = str_len(*name);
+
+	for (i=0; i < numenvs; i++) {
+		llen = str_len(e);
+		if (byte_equal(*name, nlen, e))
+			if (*(e + nlen) == '=') {
+				elen = str_chr(e + nlen + 1, '=');
+				if (*(e + nlen + elen + 1) == '=') {
+					*(e + nlen + elen + 1) = '\0';
+					if (!stralloc_copys(&vbuf,
+						    e + nlen + elen + 2))
+						die_nomem();
+					if (!stralloc_cats(&vbuf, *value))
+						die_nomem();
+					if (!stralloc_0(&vbuf)) die_nomem();
+					*value = vbuf.s;
+				}
+				*name = e + nlen + 1;
+				return;
+			}
+		e += llen + 1;
+	}
+}
+
+void setenv(char *env, unsigned int envlen)
+{
+	char *v;
+	char *e;
+	unsigned int numenv;
+	unsigned int elen;
+	unsigned int nlen;
+	unsigned int tlen;
+	unsigned int i;
+
+	if (!env_snap()) die_nomem();
+
+	numenv=(unsigned char)*env++; envlen--;
+
+	nlen=(unsigned char)*env++; envlen--;
+	for (i=0; i < numenv; i++) {
+		elen=nlen;
+		if (envlen <= 0) {
+			environ = envsnap;
+			return;
+		}
+		nlen=(unsigned char)*(env+elen);
+		*(env+elen)=0;
+		tlen = str_chr(env, '=');
+		env[tlen] = '\0';
+		e = env;
+		v = env + tlen + 1;
+		env_rewrite(&e, &v);
+		if (!env_put2(e, v)) die_nomem();
+		env+=elen+1; envlen-=(elen+1);
+	}
+}
+
+int main (int argc, char** argv)
+{
+	struct ip_address ip;
+	char **childargs;
+	char *ipstr;
+	char *s;
+	unsigned long t;
+	int sfd = -1;
+	unsigned int len;
+	int i;
+
+	childargs = argv + 1;
+	if (!*childargs) die_usage();
+
+	if (env_get("NOPBS")) goto start_daemon;
+
+	setup();
+
+	t = now() ^ getpid(); /* at least on OpenBSD this is mostly random */
+	t %= numservers;
+
+	ipstr = env_get("TCPREMOTEIP");
+	if (!ipstr) die_badenv();
+	len = ip_scan(ipstr, &ip);
+	if (len == 0 || len > 15) die_badenv();
+
+	sfd = socket(AF_INET,SOCK_DGRAM,0);
+	if (sfd == -1) goto start_daemon;
+
+	/* create request */
+	s = packet; len = 0;
+	*s++ = 'Q'; len++; /* Query */
+	*s++ = 4; len++;   /* Size of address in bytes (4 IPv4|16 IPv6) */
+	byte_copy(s, 4, &ip); s+=4; len+=4;
+	*s++ = 0; len++;   /* status */
+
+	i = sendrequest(sfd, packet, len, &servers[t]);
+	if (i <= 0) goto start_daemon;
+	t = 0;
+	do {
+		/* wait a seconds for answer */
+		i = timeoutread(1, sfd, packet, sizeof(packet));
+		if (i != -1) break;
+		if (i == -1 && errno != error_timeout) goto start_daemon;
+
+		if (t >= numservers) {
+			logit("pbscheck: no response from server");
+			goto start_daemon; /* no response */
+		}
+
+		i = sendrequest(sfd, packet, len, &servers[t]);
+		if (i <= 0) goto start_daemon;
+		t++;
+
+	} while(1);
+
+	if (packet[0] != 'R') goto start_daemon; /* R = Reply */
+	if (packet[1] != 4) goto start_daemon;
+	/* check address */
+	if (byte_diff(packet + 2, 4, &ip)) goto start_daemon;
+	if (*(packet + 2 + packet[1]) == 'R') {
+		if (!env_put("RELAYCLIENT=")) die_nomem();
+	}
+	setenv(packet + 3 + packet[1], i - packet[1] - 3);
+
+start_daemon:
+	if (sfd == -1) close(sfd); /* try to close socket */
+
+	/* start smtpd */
+	execvp(*childargs,childargs);
+	/* should never reach this point */
+	die_exec();
+	/* NOTREACHED */
+	return 1;
+}
+
+static void die(void)
+{
+	_exit(1);
+}
+
+static int safewrite(int fd, void *buf, int len)
+{
+	int r;
+	r = timeoutwrite(1200,fd,buf,len);
+	if (r <= 0) die();
+	return r;
+}
+
+static void putstr(const char *s)
+{
+	substdio_puts(&ssout,s);
+}
+
+static void flush(void)
+{
+	substdio_flush(&ssout);
+}
+
+static void errstr(const char *s)
+{
+	putstr(s);
+	putstr("\r\n");
+	flush();
+}
+
+static void logit(const char *s)
+{
+	substdio_puts(&sserr,s);
+	substdio_puts(&sserr,"\n");
+	substdio_flush(&sserr);  
+}
+
+static void die_usage(void)
+{
+	errstr("554 pop before smtp subprogram uncorrectly installed (#5.3.5)");
+	logit("usage: pbscheck subprogram ...");
+	die();
+}
+
+static void die_exec(void)
+{
+	errstr("554 unable to start smtp daemon (#5.3.5)");
+	logit("pbscheck: unable to start smtp daemon");
+	die();
+}
+
+static void die_badenv(void)
+{
+	errstr("554 unable to read $TCPREMOTEIP (#5.3.5)");
+	logit("pbscheck: unable to read $TCPREMOTEIP");
+	die();
+}
+
+static void die_control(void)
+{
+	errstr("554 unable to read controls (#5.3.5)");
+	logit("pbscheck unable to read controls");
+	die();
+}
+
+static void die_nomem(void)
+{
+	errstr("421 out of memory (#4.3.0)");
+	logit("pbscheck out of memory");
+	die();
+}
+
+static void die_envs(void)
+{
+	errstr("554 to many additional environments defined (#5.3.5)");
+	logit("pbscheck control/pbsenvs has to many entries");
+	die();
+}
+
+static void die_dir(void)
+{
+	errstr("421 chdir failed (#4.3.0)");
+	logit("pbscheck unable to open current directory");
+	die();
+}
+
+static void die_dirback(void)
+{
+	errstr("421 chdir failed (#4.3.0)");
+	logit("pbscheck unable to switch back to source directory");
+	die();
+}
+
diff -ruN qmail-1.03-orig/pbsdbd.c qmail-1.03-ldap-20060201-orig/pbsdbd.c
--- qmail-1.03-orig/pbsdbd.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/pbsdbd.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,486 @@
+/*
+ * Copyright (c) 2002-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <unistd.h>
+#include "alloc.h"
+#include "auto_qmail.h"
+#include "byte.h"
+#include "control.h"
+#include "ip.h"
+#include "ndelay.h"
+#include "now.h"
+#include "stralloc.h"
+#include "strerr.h"
+#include "substdio.h"
+#include "uint32.h"
+
+static void die_control(void);
+static void die_nomem(void);
+static void init(void);
+static int socket_bind(int);
+static void cache_impossible(void);
+static void set4(unsigned long, uint32);
+static uint32 get4(unsigned long);
+unsigned long hash(const unsigned char *,unsigned int);
+void unlinkaddr(const unsigned char *, unsigned int);
+void setaddr(const unsigned char *, unsigned int,
+    unsigned long, char *, unsigned int);
+int checkaddr(const unsigned char *, unsigned int,
+    unsigned long, char **, unsigned int *);
+static int doit(void);
+
+struct ip_address ip;
+unsigned int port = 2821;
+stralloc addr = {0};
+stralloc secret = {0};
+unsigned int timeout = 600; /* 10 Min */
+
+unsigned long cachesize = 1048576; /* 1 MB */
+unsigned char *cache;
+unsigned long hashsize;
+unsigned int hashbits;
+unsigned long writer;
+unsigned long oldest;
+unsigned long unused;
+
+static unsigned char buf[1024];
+static unsigned int len;
+
+#define fatal "pbsdbd: fatal: "
+#define warning "pbsdbd: warning: "
+#define info "pbsdbd: info: "
+
+static void
+die_control(void)
+{
+       	strerr_die2x(111, fatal, "unable to read controls");
+}
+
+static void
+die_nomem(void)
+{
+       	strerr_die2x(111, fatal, "out of memory");
+}
+
+static void
+init(void)
+{
+	unsigned int l;
+
+	if (chdir(auto_qmail) == -1) die_control();
+
+	if (control_rldef(&addr,"control/pbsip",0, "0.0.0.0") == -1)
+		die_control();
+	if (!stralloc_0(&addr)) die_nomem();
+
+	l = ip_scan(addr.s, &ip);
+	if (l == 0 && l > 15) die_control();
+
+	if (control_rldef(&secret,"control/pbssecret",0,"") != 1)
+		die_control();
+
+	if (control_readint(&port,"control/pbsport") == -1) die_control();
+	if (port > 65000) die_control();
+
+	/* if a luser sets bad values it's his fault */
+	if (control_readulong(&cachesize,"control/pbscachesize") == -1)
+		die_control();
+	if (control_readint(&timeout,"control/pbstimeout") == -1)
+		die_control();
+
+	cache = alloc(cachesize);
+	if (!cache) die_nomem();
+
+	hashsize = 4;
+	while (hashsize <= (cachesize >> 5)) hashsize <<= 1;
+
+	writer = hashsize;
+	oldest = cachesize;
+	unused = cachesize;
+
+}
+
+static int
+socket_bind(int s)
+{
+	int opt = 1;
+	struct sockaddr_in soin;
+	char *x;
+
+	setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&opt,sizeof opt);
+
+	byte_zero(&soin,sizeof(soin));
+	byte_copy(&soin.sin_addr,4,&ip);
+	x = (char *) &soin.sin_port;
+	x[1] = port; port >>= 8; x[0] = port;
+	soin.sin_family = AF_INET;
+
+	return bind(s,(struct sockaddr *) &soin,sizeof soin);
+}
+
+static void
+cache_impossible(void)
+{
+	strerr_die2x(111, fatal, "cache corrupted");
+}
+
+static void
+set4(unsigned long pos, uint32 u)
+{
+	unsigned char *s;
+
+	if (pos > cachesize - 4) cache_impossible();
+
+	s = cache + pos;
+	s[3] = u & 255;
+	u >>= 8;
+	s[2] = u & 255;
+	u >>= 8;
+	s[1] = u & 255;
+	s[0] = u >> 8;  
+}
+
+static uint32
+get4(unsigned long pos)
+{
+	unsigned char *s;
+	uint32 result;  
+
+	if (pos > cachesize - 4) cache_impossible();
+	s = cache + pos;
+	result = s[0];
+	result <<= 8;
+	result += s[1];
+	result <<= 8;
+	result += s[2];
+	result <<= 8;
+	result += s[3];
+
+	return result;
+}
+
+unsigned long
+hash(const unsigned char *key,unsigned int keylen)
+{
+	unsigned long result = 5381;
+
+	while (keylen) {
+		result = (result << 5) + result;
+		result ^= *key;
+		++key;
+		--keylen;
+	}
+	result <<= 2;
+	result &= hashsize - 4;
+	return result;
+}
+
+void
+unlinkaddr(const unsigned char *key, unsigned int keylen)
+{
+	unsigned long pos;
+	unsigned long prevpos;
+	unsigned long nextpos;
+	unsigned int loop;
+
+	if (!cache) return;
+
+	prevpos = hash(key,keylen);
+	pos = get4(prevpos);
+	loop = 0;
+
+	while (pos) {
+		if (pos + 13 > cachesize) cache_impossible();
+		nextpos = prevpos ^ get4(pos);
+		if (nextpos == prevpos) cache_impossible();
+		if (*(cache + pos + 12) == keylen) {
+			if (pos + 13 + keylen > cachesize) cache_impossible();
+			if (byte_equal(key,keylen,cache + pos + 13)) {
+				set4(prevpos, get4(prevpos) ^ pos ^ nextpos);
+				if (nextpos != 0)
+					set4(nextpos,
+					    get4(nextpos) ^ pos ^ prevpos);
+				set4(pos, 0);
+				//strerr_warn2(info, "clearing entry.", 0);
+				return;
+			}
+		}
+		prevpos = pos;
+		pos = nextpos;
+		if (++loop > 100) {
+			strerr_warn2(warning, "hash flooding", 0);
+			return; /* to protect against hash flooding */
+		}
+	}
+}
+
+/* to be stored: 4-byte link, 4-byte timestamp, 4-byte envsize, 1-byte size,
+   size-byte Address and envsize-byte Environment */
+/* see also dnscache */
+void
+setaddr(const unsigned char *key, unsigned int keylen,
+    unsigned long timenow, char *env, unsigned int envlen)
+{
+	unsigned int entrylen;
+	unsigned int tmplen;
+	unsigned int keyhash;
+	unsigned long pos;
+
+	if (!cache) return;
+	if (keylen > 255) return;
+
+	entrylen = 13 + keylen + envlen;
+
+	unlinkaddr(key, keylen);
+
+	while (writer + entrylen > oldest) {
+		if (oldest == unused) {
+			if (writer <= hashsize) cache_impossible();
+			unused = writer;
+			oldest = hashsize;
+			writer = hashsize;
+			strerr_warn2(info, "reached end of cache, wrapping...", 0);
+		}
+
+		pos = get4(oldest);
+		if (!pos)
+			strerr_warn2(info, "skipping cleared entry", 0);
+		if (pos)
+			set4(pos,get4(pos) ^ oldest);
+
+		if (oldest + 13 > cachesize) cache_impossible();
+		tmplen = get4(oldest + 8);
+		oldest += 13 + tmplen + *(cache + oldest + 12);
+		if (oldest > unused) cache_impossible();
+		if (oldest == unused) {
+			unused = cachesize;
+			oldest = cachesize;
+		}
+	}
+
+	keyhash = hash(key,keylen);
+
+	pos = get4(keyhash);
+	if (pos)
+		set4(pos,get4(pos) ^ keyhash ^ writer);
+	set4(writer,pos ^ keyhash);
+	set4(writer + 4,timenow + timeout);
+	set4(writer + 8,envlen);
+	if (writer + 13 > cachesize) cache_impossible();
+	*(cache + writer + 12) = keylen;
+	byte_copy(cache + writer + 13,keylen,key);
+	byte_copy(cache + writer + 13 + keylen,envlen,env);
+
+	set4(keyhash,writer);
+
+	writer += entrylen;
+}
+
+int
+checkaddr(const unsigned char *key, unsigned int keylen,
+    unsigned long timenow, char **env, unsigned int *envlen)
+{
+	unsigned long pos;
+	unsigned long prevpos;
+	unsigned long nextpos;
+	unsigned long u;
+	unsigned int loop;
+
+	if (!cache) return 0;
+
+	prevpos = hash(key,keylen);
+	pos = get4(prevpos);
+	loop = 0;
+	*env = 0;
+	*envlen = 0;
+
+	while (pos) {
+		if (pos + 13 > cachesize) cache_impossible();
+		if (*(cache + pos + 12) == keylen) {
+			if (pos + 13 + keylen > cachesize) cache_impossible();
+			if (byte_equal(key,keylen,cache + pos + 13)) {
+				u = get4(pos + 4);
+				if (u < timenow) {
+					//strerr_warn2(info,
+					//    "cache hit but timed out", 0);
+					return 0;
+				}
+				*envlen = get4(pos + 8);
+				if (pos + 13 + keylen + *envlen > cachesize)
+					cache_impossible();
+				*env = cache + pos + 13 + keylen;
+				return 1;
+			}
+		}
+		nextpos = prevpos ^ get4(pos);
+		if (nextpos == prevpos) cache_impossible();
+		prevpos = pos;
+		pos = nextpos;
+		if (++loop > 100) {
+			strerr_warn2(warning, "hash flooding", 0);
+			return 0; /* to protect against hash flooding */
+		}
+	}
+
+	//strerr_warn2(info, "not in cache", 0);
+	return 0;
+}
+
+
+/*
+ * pbs packets have following format:
+ *   header:
+ *   1-byte type, 1-byte address-size, address-size-byte
+ *
+ *   secret used in type add packets:
+ *   1-byte secret-size, secret-size-bytes secret
+ *
+ *   may-relay byte used in respnse packets:
+ *   1-byte may-relay ('R' for may-relay and 'N' for may-not-relay)
+ *
+ *   optional environment vars for type add and result:
+ *   1-byte #-of-entries
+ *   environment vars entries
+ *   1-byte size, n-byte env-name, 1-byte '"', m-byte env-var
+ *   where n + m + 1 = size.
+ *
+ *   Allowed types are 'A' for add, 'Q' for query, 'R' response.
+ *   Type 'A' uses the header and secret plus optional environment vars.
+ *   Type 'Q' does only need the header.
+ *   Type 'R' needs the header and the may-relay byte and
+ *   optional environment vars.
+ */
+
+static int doit(void)
+{
+	unsigned char *sec;
+	unsigned int sec_len;
+	unsigned char *env;
+	unsigned long timenow;
+	unsigned int envlen;
+	unsigned int i;
+
+	if ((unsigned int)buf[1] + 2 >= len) {
+		strerr_warn2(warning, "bad packet", 0);
+		return 0;
+	}
+
+	timenow = now();
+
+	switch (buf[0]) {
+	case 'Q':
+		//strerr_warn2(info, "query packet", 0);
+		if (checkaddr(&buf[2], buf[1], timenow,
+			    (char**)&env, &envlen)) {
+			*(buf + 2 + buf[1]) = 'R';
+			if (envlen + buf[1] + 3 > 1024) {
+				strerr_warn2(warning, "environment would "
+				    "exceed package size, dropped", 0);
+				return 0;
+			}
+			byte_copy(buf+3+buf[1], envlen, env);
+			len += envlen;
+		} else {
+			*(buf + 2 + buf[1]) = 'N';
+		}
+		buf[0] = 'R';
+		return 1;
+	case 'A':
+		//strerr_warn2(info, "add packet", 0);
+		sec_len = *(buf + 2 + buf[1]);
+		sec = buf + 2 + buf[1] + 1;
+		if (buf + len < sec + sec_len) {
+			strerr_warn2(warning, "bad packet", 0);
+			return 0;
+		}
+		if (secret.len != sec_len ||
+		    byte_diff(secret.s, sec_len, sec)) {
+			strerr_warn2(warning, "no authorized add packet", 0);
+			return 0;
+		}
+		env = buf + 3 + buf[1] + *(buf + 2 + buf[1]);
+		envlen = 1;
+		for (i=0; i < *env; i++) {
+			envlen += env[envlen] + 1;
+			if (buf + len < env + envlen) {
+				strerr_warn2(warning, "environment would "
+				    "exceed package size, dropped", 0);
+				return 0;
+			}
+		}
+		if (buf + len != env + envlen) {
+			strerr_warn2(warning, "trailing garbadge at end "
+			    "of packet, dropped", 0);
+			return 0;
+		}
+		setaddr(&buf[2], buf[1], timenow, env, envlen);
+		return 0;
+	case 'R':
+		strerr_warn2(warning, "response recived", 0);
+		return 0;
+	default:
+		strerr_warn2(warning, "bad packet", 0);
+		return 0;
+	}
+}
+
+int main(int argc, char** argv)
+{
+	struct sockaddr_in sa;
+	unsigned int dummy;
+	int udp;
+
+	init();
+
+	udp = socket(AF_INET, SOCK_DGRAM, 0);
+	if (udp == -1)
+		strerr_die2sys(111,fatal,"unable to create UDP socket: ");
+	if (socket_bind(udp) == -1)
+		strerr_die2sys(111,fatal,"unable to bind UDP socket: ");
+
+	ndelay_off(udp);
+
+	for (;;) {
+		dummy = sizeof(sa);
+		len = recvfrom(udp, buf, sizeof(buf), 0,
+		    (struct sockaddr*) &sa, &dummy);
+		if (len < 0) continue;
+		if (!doit()) continue;
+		sendto(udp, buf, len, 0, (struct sockaddr*) &sa, sizeof(sa));
+		/* may block for buffer space; if it fails, too bad */
+	}
+}
+
diff -ruN qmail-1.03-orig/pbsexec.c qmail-1.03-ldap-20060201-orig/pbsexec.c
--- qmail-1.03-orig/pbsexec.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/pbsexec.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,80 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <unistd.h>
+#include "env.h"
+#include "open.h"
+#include "qldap-debug.h"
+#include "wait.h"
+
+#include "pbsexec.h"
+
+char *pbstool = 0;
+
+void
+pbsexec(void)
+{
+	char *(args[3]);
+	int child, wstat;
+
+	if (pbstool == 0 || *pbstool == 0) return;
+
+	if (env_get("NOPBS")) return;
+
+	switch (child = fork()) {
+	case -1:
+		return;
+	case 0:
+		/* the pbstool may not read or write to the connection */
+		close(0); open_read("/dev/null");
+		close(1); open_write("/dev/null");
+		close(3);
+		
+		args[0] = pbstool;
+		args[1] = 0;
+		execvp(*args, args);
+		_exit(111);
+	}
+
+	wait_pid(&wstat,child);
+	if (wait_crashed(wstat))
+		logit(2, "pbsexec: %s crashed\n", pbstool);
+	else if (wait_exitcode(wstat))
+		logit(2, "pbsexec: %s failed, exit code %d\n",
+		    pbstool, wait_exitcode(wstat));
+	else
+		logit(64, "pbsexec: %s OK\n", pbstool);
+
+	return;
+}
+
diff -ruN qmail-1.03-orig/pbsexec.h qmail-1.03-ldap-20060201-orig/pbsexec.h
--- qmail-1.03-orig/pbsexec.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/pbsexec.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,41 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __PBSEXEC_H__
+#define __PBSEXEC_H__
+
+extern char *pbstool;
+
+void pbsexec(void);
+
+#endif
